chiark / gitweb /
we have comp now
[dgit.git] / dgit
diff --git a/dgit b/dgit
index 7e464fe0a34fd08fc076385b980545bef8a20502..da98bd5c7926f2e1e49c58b37abb93a5d4aea9b1 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,7 +26,6 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
 
@@ -42,6 +41,7 @@ our (@dput) = qw(dput);
 our (@debsign) = qw(debsign);
 our $keyid;
 
+our $debug = 0;
 open DEBUG, ">/dev/null" or die $!;
 
 our %opts_opt_map = ('dget' => \@dget,
@@ -49,7 +49,7 @@ our %opts_opt_map = ('dget' => \@dget,
                     'debsign' => \@debsign);
 
 our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-Git-Master';
+our $ourdscfield = 'Vcs-Dgit-Master';
 our $branchprefix = 'dgit';
 
 sub lbranch () { return "$branchprefix/$suite"; }
@@ -96,13 +96,14 @@ sub printcmd {
 }
 
 sub runcmd {
-    printcmd(\*DEBUG,"+",@_);
+    printcmd(\*DEBUG,"+",@_) if $debug>0;
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
 sub cmdoutput_errok {
-    printcmd(\*DEBUG,"|",@_);
+    die Dumper(\@_)." ?" if grep { !defined } @_;
+    printcmd(\*DEBUG,"|",@_) if $debug>0;
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
@@ -133,15 +134,22 @@ sub runcmd_ordryrun {
 
 our %defcfg = ('dgit.default.distro' => 'debian',
               'dgit.default.username' => '',
+              'dgit.default.archive-query-default-component' => 'main',
+              'dgit.default.ssh' => 'ssh',
               'dgit-distro.debian.git-host' => 'git.debian.org',
               'dgit-distro.debian.git-proto' => 'git+ssh://',
               'dgit-distro.debian.git-path' => '/git/dgit-repos',
               'dgit-distro.debian.git-check' => 'ssh-cmd',
-              'dgit-distro.debian.git-create' => 'ssh-cmd');
+              'dgit-distro.debian.git-create' => 'ssh-cmd',
+              'dgit-distro.debian.mirror' => 'http://ftp.debian.org/debian/');
 
 sub cfg {
     foreach my $c (@_) {
-       my $v = cmdoutput_errok qw(git config --), $c;
+       my $v;
+       {
+           local ($debug) = $debug-1;
+           $v = cmdoutput_errok(@git, qw(config --), $c);
+       };
        if ($?==0) {
            chomp $v;
            return $v;
@@ -154,10 +162,14 @@ sub cfg {
     return undef;
 }
 
+sub access_distro () {
+    return cfg("dgit-suite.$suite.distro",
+              "dgit.default.distro");
+}
+
 sub access_cfg ($) {
     my ($key) = @_;
-    my $distro = cfg("dgit-suite.$suite.distro",
-                    "dgit.default.distro"); });
+    my $distro = access_distro();
     my $value = cfg("dgit-distro.$distro.$key",
                    "dgit.default.$key");
     return $value;
@@ -171,11 +183,13 @@ sub access_gituserhost () {
 
 sub access_giturl () {
     my $url = access_cfg('git-url');
-    return $url if defined $url;
-    return
-       access_cfg('git-proto').
-       access_gituserhost().
-       access_cfg('git-path');
+    if (!defined $url) {
+       $url =
+           access_cfg('git-proto').
+           access_gituserhost().
+           access_cfg('git-path');
+    }
+    return "$url/$package.git";
 }             
 
 sub parsecontrol {
@@ -195,12 +209,18 @@ sub parsechangelog {
 
 our $rmad;
 
-sub askmadison () {
-    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite",$package;
-    $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
+sub archive_query () {
+    my $query = access_cfg('archive-query');
+    $query ||= "madison:".access_distro();
+    $query =~ s/^(\w+):// or die "$query ?";
+    my $proto = $1;
+    my $url = $'; #';
+    die unless $proto eq 'madison';
+    $rmad ||= cmdoutput qw(rmadison -asource),"-s$suite","-u$url",$package;
+    $rmad =~ m{^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
+                 \s*( [^ \t|/]+ )(?:/([^ \t|/]+)) \s* \|
+                 \s*( [^ \t|]+ )\s* }x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
     if ($suite ne $3) {
@@ -208,41 +228,44 @@ sub askmadison () {
        print "canonical suite name for $suite is $3\n";
        $suite = $3;
     }
-    $4 eq 'source' or die "$rmad ?";
-    return $vsn;
+    my $component;
+    if (defined $4) {
+       $component = $4;
+    } else {
+       $component = access_cfg('archive-query-default-component');
+    }
+    $5 eq 'source' or die "$rmad ?";
+    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
+    my $subpath = "/pool/$component/$prefix/$package/${package}_$vsn.dsc";
+    return ($vsn,$subpath);
 }
 
 sub canonicalise_suite () {
-    askmadison();
+    archive_query();
 }
 
 sub get_archive_dsc () {
-    my $vsn = askmadison();
-    # fixme madison does not show us the component
-    my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
-    $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
+    my ($vsn,$subpath) = archive_query();
+    $dscurl = access_cfg('mirror').$subpath;
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-    print DEBUG Dumper($dscdata);
+    print DEBUG Dumper($dscdata) if $debug>1;
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-    print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc) if $debug>1;
     my $fmt = $dsc->{Format};
     die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
-    my $how = access_config('git-check');
+    my $how = access_cfg('git-check');
     if ($how eq 'ssh-cmd') {
-       my $r= cmd_getoutput access_cfg('ssh'),access_gituserhost(),
-           " set -e; cd ".access_cfg('git-path').";".
-           " if test -d $package.git; then echo 1; else echo 0; fi";
-       print DEBUG "$cmd\n";
-       open P, "$cmd |" or die $!;
-       $!=0; $?=0;
-       my $r = <P>; close P;
-       print DEBUG ">$r<\n";
+       my $r= cmdoutput
+           (access_cfg('ssh'),access_gituserhost(),
+            " set -e; cd ".access_cfg('git-path').";".
+            " if test -d $package.git; then echo 1; else echo 0; fi");
+       print DEBUG "got \`$r'\n";
        die "$r $! $?" unless $r =~ m/^[01]$/;
        return $r+0;
     } else {
@@ -251,13 +274,14 @@ sub check_for_git () {
 }
 
 sub create_remote_git_repo () {
-    my $how = access_config('git-create');
+    my $how = access_cfg('git-create');
     if ($how eq 'ssh-cmd') {
-       runcmd_ordryrun access_cfg('ssh'),access_gituserhost(),
-           "set -e; cd ".access_cfg('git-path').";".
-           " mkdir -p $package.git;".
-           " cd $package.git;".
-           " if ! test -d objects; then git init --bare; fi";
+       runcmd_ordryrun
+           (access_cfg('ssh'),access_gituserhost(),
+            "set -e; cd ".access_cfg('git-path').";".
+            " mkdir -p $package.git;".
+            " cd $package.git;".
+            " if ! test -d objects; then git init --bare; fi");
     } else {
        die "unknown git-create $how ?";
     }
@@ -405,7 +429,7 @@ sub is_fast_fwd ($$) {
 
 sub git_fetch_us () {
     die "cannot dry run with fetch" if $dryrun;
-    runcmd @git, qw(fetch),$remotename,fetchspec();
+    runcmd @git, qw(fetch),access_giturl(),fetchspec();
 }
 
 sub fetch_from_archive () {
@@ -423,10 +447,13 @@ sub fetch_from_archive () {
 
     $!=0; $upload_hash =
        cmdoutput_errok @git, qw(show-ref --heads), lrref();
-    die $! if $!;
-    die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==256 && !length $upload_hash);
-    $upload_hash ||= '';
+    if ($?==0) {
+       die unless chomp $upload_hash;
+    } elsif ($?==256) {
+       $upload_hash = '';
+    } else {
+       die $?;
+    }
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
@@ -461,7 +488,7 @@ sub clone ($) {
     open H, "> .git/HEAD" or die $!;
     print H "ref: ".lref()."\n" or die $!;
     close H or die $!;
-    runcmd @git, qw(remote add), 'origin', access_giturl($package);
+    runcmd @git, qw(remote add), 'origin', access_giturl();
     if (check_for_git()) {
        print "fetching existing git history\n";
        git_fetch_us();
@@ -490,7 +517,6 @@ sub pull () {
 sub dopush () {
     runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
-    die if defined $package;
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
     stat "../$dscfn" or die "$dscfn $!";
@@ -525,7 +551,7 @@ sub dopush () {
     if (!check_for_git()) {
        create_remote_git_repo();
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"HEAD:".rrref();
+    runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
     if ($sign) {
        my @tag_cmd = (@git, qw(tag -s -m),
                       "Release $dsc->{Version} for $suite [dgit]");
@@ -537,8 +563,10 @@ sub dopush () {
        push @debsign_cmd, $changesfile;
        runcmd_ordryrun @debsign_cmd;
     }
-    runcmd_ordryrun @git, qw(push),$remotename,"refs/tags/$tag";
-    runcmd_ordryrun @dput, $changesfile;
+    runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
+    my $host = access_cfg('upload-host');
+    my @hostarg = defined($host) ? ($host,) : ();
+    runcmd_ordryrun @dput, @hostarg, $changesfile;
 }
 
 sub cmd_clone {
@@ -649,8 +677,9 @@ sub parseopts () {
                    $dryrun=1;
                } elsif (s/^-D/-/) {
                    open DEBUG, ">&STDERR" or die $!;
+                   $debug++;
                } elsif (s/^-c(.*=.*)//s) {
-                   push @git, $1;
+                   push @git, '-c', $1;
                } elsif (s/^-C(.*)//s) {
                    $changesfile = $1;
                } elsif (s/^-k(.*)//s) {